/* Header file to define the control message format as well as any
 * constants that might be needed for a base station
 * 
 * @author Jung Woo Lee, <jungwoo@cs.stanford.edu>
 * @date Sep 11 2009
 * @updated Sept 11 2009
 *
 */

typedef nx_struct control_msg_t {
    nx_uint8_t type;
    nx_am_addr_t startID;
    nx_am_addr_t endID;
}control_msg_t;

enum {
    INITIATE = 1,
};

//WaitTimer constants
enum {
    MAX_PINGING	     = 10,           //maximum number of pingings before deciding there is no node around
    MAX_CONTROL_RETRANSMISSIONS = 5, //maximum number of retransmissions of the "start_transfer" packet

    PINGING_INTERVAL = 256,          //time interval between pinging
    WAIT_BEFORE_COLLECTION = 512,    //wait until other nodes are calm down
    MAX_DATA_INTERVAL = 1024,        //maximum allowed interval between data transfers. If no packet is received in this interval, 
                                     //the base-station assumes that the connection to a node is broken.
};
