# progamming multiple motes connected to USB serial ports
# Written by Jung Woo Lee (jungwoo@gmail.com)
# modified in Nov 9, 2009

#! /usr/bin/python
import os
import re
import tempfile
import numpy
import sys
import time
import copy

local_ip=[ "/dev/ttyUSB0","/dev/ttyUSB1","/dev/ttyUSB2",
           "/dev/ttyUSB3","/dev/ttyUSB4","/dev/ttyUSB5",
           "/dev/ttyUSB6","/dev/ttyUSB7" ]
num_nodes = 0

#1. getting the TOS_NODE_ID(i) for a mote in USB0. TOS_NODE_ID in USBx will be x+i
if len(sys.argv) < 3:
   print "Usage: python install.py [num of motes] [first node id or all ids] ex) python install.py 2 0 or python install.py 2 0 1"
   sys.exit()
elif len(sys.argv) == 3:
   num_nodes = int(sys.argv[1])
   ids       = numpy.zeros(num_nodes, int)
   first_id  = int(sys.argv[2])
   for i in range(num_nodes):
       ids[i] = first_id + i
else:
   num_nodes = int(sys.argv[1])
   print "num_nodes = %s" %num_nodes
   ids       = numpy.zeros(num_nodes, int)
   for i in range(num_nodes):
       ids[i] = int(sys.argv[2+i])

def upload_main(in_ip, in_idx):
   #z_1=$3 #packet interval in ticks
   cmd="tos-set-symbols --objcopy msp430-objcopy --objdump msp430-objdump --target ihex build/telosb/main.ihex build/telosb/main.ihex.out-%s TOS_NODE_ID=%s" %(in_idx, in_idx) 
   os.system(cmd)
   cmd="tos-bsl --telosb -c %s -r -e -I -p build/telosb/main.ihex.out-%s" %(in_ip, in_idx)
   os.system(cmd)
   print "Uploaded an executable into %s with node ID %s" %(in_ip,in_idx)

def null(in_ip):
   print "erasing node %s" %in_ip
   cmd="tos-bsl --telosb -c %s -r -e -I -p ../Eraser/build/telosb/main.ihex" %(in_ip)
   os.system(cmd)

def install_null():
   for i in range(num_nodes):
      pid= os.fork()
      if not pid:         #child process
         null(local_ip[i])
         sys.exit()

def install_protocol():
   for i in range(num_nodes):
      pid = os.fork()
      if not pid: #a child process
         upload_main(local_ip[i], ids[i])
         sys.exit()

print "compiling the program ..."
cmd="make telosb"
os.system(cmd)
time.sleep(15)

print "erasing motes ...."
install_null()
time.sleep(25)

print "installing the program ...."
install_protocol()
sys.exit()
